var camera;
var number;

module("VZ.Camera", {
  setup: function() {
    camera = new VZ.Camera();
    number = Math.floor((Math.random() * 100) + 1);
  }, teardown: function() {
    delete camera;
    delete number;
  }
});
test( "new", function() {
  ok( (camera !== undefined && camera !== null), "camera is initialized" );
});
test( "position.set", function() {
  camera.position.set(1,2,3);
  equal(camera.position.x, 1);
  equal(camera.position.y, 2);
  equal(camera.position.z, 3);
});
test( "position=", function() {
  camera.position.x = 10;
  camera.position.y = 20;
  camera.position.z = 30;
  equal(camera.position.x, 10);
  equal(camera.position.y, 20);
  equal(camera.position.z, 30);
});
test( "saveState", function() {
  camera.position.set(1,2,3);
  camera.aspect = 30;
  camera.fov = 40;
  camera.near = 50;
  camera.far = 60;
  camera.saveState(number);
  equal(camera.state[number].aspect, 30, "aspect");
  equal(camera.state[number].fov, 40, "fov");
  equal(camera.state[number].near, 50, "near");
  equal(camera.state[number].far, 60, "far");
  equal(camera.state[number].position.x, 1, "x");
  equal(camera.state[number].position.y, 2, "y");
  equal(camera.state[number].position.z, 3, "z");
});
test( "restoreState", function() {
  camera.state[number] = {
    aspect: 123,
    fov: 234,
    near: 345,
    far: 456,
    position: new THREE.Vector3(9, 10, 11),
    target: new THREE.Vector3(13, 14, 15)
  }
  camera.restoreState(number);
  equal(camera.aspect, 123, "aspect");
  equal(camera.fov, 234, "fov");
  equal(camera.near, 345, "near");
  equal(camera.far, 456, "far");
  equal(camera.position.x, 9, "x");
  equal(camera.position.y, 10, "y");
  equal(camera.position.z, 11, "z");
});
